Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 4648)
@@ -401,43 +397,40 @@
     ALLOCATE( drho_air_zw(nzb:nzt+1) )
 !
-!-- Density profile calculation for anelastic and Boussinesq approximation
-!-- In case of a Boussinesq approximation, a constant density is calculated
-!-- mainly for output purposes. This density do not need to be considered 
-!-- in the model's system of equations.
+!-- Density profile calculation for anelastic and Boussinesq approximation.
+!-- In case of a Boussinesq approximation, a constant density is calculated mainly for output
+!-- purposes. This density does not need to be considered in the model's system of equations.
     IF ( TRIM( approximation ) == 'anelastic' )  THEN
        DO  k = nzb, nzt+1
-          p_hydrostatic(k) = barometric_formula(zu(k), pt_surface *            & 
-                             exner_function(surface_pressure * 100.0_wp),      &
-                             surface_pressure * 100.0_wp)
-          
+          p_hydrostatic(k) = barometric_formula(zu(k), pt_surface *                                &
+                                                exner_function(surface_pressure * 100.0_wp),       &
+                                                surface_pressure * 100.0_wp)
+
           rho_air(k) = ideal_gas_law_rho_pt(p_hydrostatic(k), pt_init(k))
        ENDDO
-       
+
        DO  k = nzb, nzt
           rho_air_zw(k) = 0.5_wp * ( rho_air(k) + rho_air(k+1) )
        ENDDO
-       
-       rho_air_zw(nzt+1)  = rho_air_zw(nzt)                                    &
-                            + 2.0_wp * ( rho_air(nzt+1) - rho_air_zw(nzt)  )
-                            
+
+       rho_air_zw(nzt+1)  = rho_air_zw(nzt) + 2.0_wp * ( rho_air(nzt+1) - rho_air_zw(nzt)  )
+
     ELSE
        DO  k = nzb, nzt+1
-          p_hydrostatic(k) = barometric_formula(zu(nzb), pt_surface *          & 
-                             exner_function(surface_pressure * 100.0_wp),      &
-                             surface_pressure * 100.0_wp)
+          p_hydrostatic(k) = barometric_formula(zu(nzb), pt_surface *                              &
+                                                exner_function(surface_pressure * 100.0_wp),       &
+                                                surface_pressure * 100.0_wp)
 
           rho_air(k) = ideal_gas_law_rho_pt(p_hydrostatic(k), pt_init(nzb))
        ENDDO
-       
+
        DO  k = nzb, nzt
           rho_air_zw(k) = 0.5_wp * ( rho_air(k) + rho_air(k+1) )
        ENDDO
-       
-       rho_air_zw(nzt+1)  = rho_air_zw(nzt)                                    &
-                            + 2.0_wp * ( rho_air(nzt+1) - rho_air_zw(nzt)  )
-                            
-    ENDIF
-!
-!-- compute the inverse density array in order to avoid expencive divisions
+
+       rho_air_zw(nzt+1)  = rho_air_zw(nzt) + 2.0_wp * ( rho_air(nzt+1) - rho_air_zw(nzt)  )
+
+    ENDIF
+!
+!-- Compute the inverse density array in order to avoid expencive divisions
     drho_air    = 1.0_wp / rho_air
     drho_air_zw = 1.0_wp / rho_air_zw
@@ -453,5 +446,5 @@
 
 !
-!-- calculate flux conversion factors according to approximation and in-/output mode
+!-- Calculate flux conversion factors according to approximation and in-/output mode
     DO  k = nzb, nzt+1
 
@@ -484,6 +477,6 @@
 
 !
-!-- In case of multigrid method, compute grid lengths and grid factors for the
-!-- grid levels with respective density on each grid
+!-- In case of multigrid method, compute grid lengths and grid factors for the grid levels with
+!-- respective density on each grid.
     IF ( psolver(1:9) == 'multigrid' )  THEN
 
@@ -500,9 +493,8 @@
        dzu_mg(:,maximum_grid_level) = dzu
        rho_air_mg(:,maximum_grid_level) = rho_air
-!       
-!--    Next line to ensure an equally spaced grid. 
+!
+!--    Next line to ensure an equally spaced grid.
        dzu_mg(1,maximum_grid_level) = dzu(2)
-       rho_air_mg(nzb,maximum_grid_level) = rho_air(nzb) +                     &
-                                             (rho_air(nzb) - rho_air(nzb+1))
+       rho_air_mg(nzb,maximum_grid_level) = rho_air(nzb) + (rho_air(nzb) - rho_air(nzb+1))
 
        dzw_mg(:,maximum_grid_level) = dzw
@@ -512,6 +504,8 @@
            dzu_mg(nzb+1,l) = 2.0_wp * dzu_mg(nzb+1,l+1)
            dzw_mg(nzb+1,l) = 2.0_wp * dzw_mg(nzb+1,l+1)
-           rho_air_mg(nzb,l)    = rho_air_mg(nzb,l+1) + (rho_air_mg(nzb,l+1) - rho_air_mg(nzb+1,l+1))
-           rho_air_zw_mg(nzb,l) = rho_air_zw_mg(nzb,l+1) + (rho_air_zw_mg(nzb,l+1) - rho_air_zw_mg(nzb+1,l+1))
+           rho_air_mg(nzb,l)    = rho_air_mg(nzb,l+1)    + ( rho_air_mg(nzb,l+1)    -              &
+                                                             rho_air_mg(nzb+1,l+1)    )
+           rho_air_zw_mg(nzb,l) = rho_air_zw_mg(nzb,l+1) + ( rho_air_zw_mg(nzb,l+1) -              &
+                                                             rho_air_zw_mg(nzb+1,l+1) )
            rho_air_mg(nzb+1,l)    = rho_air_mg(nzb+1,l+1)
            rho_air_zw_mg(nzb+1,l) = rho_air_zw_mg(nzb+1,l+1)
@@ -534,5 +528,5 @@
              f2_mg(k,l) = rho_air_zw_mg(k,l) / ( dzu_mg(k+1,l) * dzw_mg(k,l) )
              f3_mg(k,l) = rho_air_zw_mg(k-1,l) / ( dzu_mg(k,l)   * dzw_mg(k,l) )
-             f1_mg(k,l) = 2.0_wp * ( ddx2_mg(l) + ddy2_mg(l) ) &
+             f1_mg(k,l) = 2.0_wp * ( ddx2_mg(l) + ddy2_mg(l) )                                     &
                           * rho_air_mg(k,l) + f2_mg(k,l) + f3_mg(k,l)
           ENDDO
@@ -552,37 +546,34 @@
 
 !
-!-- Arrays to store velocity data from t-dt and the phase speeds which
-!-- are needed for radiation boundary conditions
+!-- Arrays to store velocity data from t-dt and the phase speeds which are needed for radiation
+!-- boundary conditions.
     IF ( bc_radiation_l )  THEN
-       ALLOCATE( u_m_l(nzb:nzt+1,nysg:nyng,1:2),                               &
-                 v_m_l(nzb:nzt+1,nysg:nyng,0:1),                               &
+       ALLOCATE( u_m_l(nzb:nzt+1,nysg:nyng,1:2),                                                   &
+                 v_m_l(nzb:nzt+1,nysg:nyng,0:1),                                                   &
                  w_m_l(nzb:nzt+1,nysg:nyng,0:1) )
     ENDIF
     IF ( bc_radiation_r )  THEN
-       ALLOCATE( u_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                           &
-                 v_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                           &
+       ALLOCATE( u_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                                               &
+                 v_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                                               &
                  w_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx) )
     ENDIF
     IF ( bc_radiation_l  .OR.  bc_radiation_r )  THEN
-       ALLOCATE( c_u(nzb:nzt+1,nysg:nyng), c_v(nzb:nzt+1,nysg:nyng),           &
-                 c_w(nzb:nzt+1,nysg:nyng) )
+       ALLOCATE( c_u(nzb:nzt+1,nysg:nyng), c_v(nzb:nzt+1,nysg:nyng), c_w(nzb:nzt+1,nysg:nyng) )
     ENDIF
     IF ( bc_radiation_s )  THEN
-       ALLOCATE( u_m_s(nzb:nzt+1,0:1,nxlg:nxrg),                               &
-                 v_m_s(nzb:nzt+1,1:2,nxlg:nxrg),                               &
+       ALLOCATE( u_m_s(nzb:nzt+1,0:1,nxlg:nxrg),                                                   &
+                 v_m_s(nzb:nzt+1,1:2,nxlg:nxrg),                                                   &
                  w_m_s(nzb:nzt+1,0:1,nxlg:nxrg) )
     ENDIF
     IF ( bc_radiation_n )  THEN
-       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                           &
-                 v_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                           &
+       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                                               &
+                 v_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                                               &
                  w_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg) )
     ENDIF
     IF ( bc_radiation_s  .OR.  bc_radiation_n )  THEN
-       ALLOCATE( c_u(nzb:nzt+1,nxlg:nxrg), c_v(nzb:nzt+1,nxlg:nxrg),           &
-                 c_w(nzb:nzt+1,nxlg:nxrg) )
-    ENDIF
-    IF ( bc_radiation_l  .OR.  bc_radiation_r  .OR.  bc_radiation_s  .OR.      &
-         bc_radiation_n )  THEN
-       ALLOCATE( c_u_m_l(nzb:nzt+1), c_v_m_l(nzb:nzt+1), c_w_m_l(nzb:nzt+1) )                   
+       ALLOCATE( c_u(nzb:nzt+1,nxlg:nxrg), c_v(nzb:nzt+1,nxlg:nxrg), c_w(nzb:nzt+1,nxlg:nxrg) )
+    ENDIF
+    IF ( bc_radiation_l  .OR.  bc_radiation_r  .OR.  bc_radiation_s  .OR.  bc_radiation_n )  THEN
+       ALLOCATE( c_u_m_l(nzb:nzt+1), c_v_m_l(nzb:nzt+1), c_w_m_l(nzb:nzt+1) )
        ALLOCATE( c_u_m(nzb:nzt+1), c_v_m(nzb:nzt+1), c_w_m(nzb:nzt+1) )
     ENDIF
@@ -603,8 +594,8 @@
        vpt  => vpt_1
     ENDIF
-    
+
     IF ( passive_scalar )  THEN
        s => s_1;  s_p => s_2;  ts_m => s_3
-    ENDIF    
+    ENDIF
 
 !
@@ -617,15 +608,14 @@
 
 !
-!-- Allocate arrays containing the RK coefficient for calculation of 
-!-- perturbation pressure and turbulent fluxes. At this point values are
-!-- set for pressure calculation during initialization (where no timestep
-!-- is done). Further below the values needed within the timestep scheme
-!-- will be set.
-    ALLOCATE( weight_substep(1:intermediate_timestep_count_max),               &
+!-- Allocate arrays containing the RK coefficient for calculation of perturbation pressure and
+!-- turbulent fluxes. At this point values are set for pressure calculation during initialization
+!-- (where no timestep is done). Further below the values needed within the timestep scheme will be
+!-- set.
+    ALLOCATE( weight_substep(1:intermediate_timestep_count_max),                                   &
               weight_pres(1:intermediate_timestep_count_max) )
     weight_substep = 1.0_wp
     weight_pres    = 1.0_wp
     intermediate_timestep_count = 0  ! needed when simulated_time = 0.0
-       
+
     IF ( debug_output )  CALL debug_message( 'allocating arrays', 'end' )
 
@@ -636,15 +626,14 @@
 !
 !-- Initialize local summation arrays for routine flow_statistics.
-!-- This is necessary because they may not yet have been initialized when they
-!-- are called from flow_statistics (or - depending on the chosen model run -
-!-- are never initialized)
-    sums_divnew_l      = 0.0_wp
-    sums_divold_l      = 0.0_wp
-    sums_l_l           = 0.0_wp
-    sums_wsts_bc_l     = 0.0_wp
-    
+!-- This is necessary because they may not yet have been initialized when they are called from
+!-- flow_statistics (or - depending on the chosen model run - are never initialized)
+    sums_divnew_l  = 0.0_wp
+    sums_divold_l  = 0.0_wp
+    sums_l_l       = 0.0_wp
+    sums_wsts_bc_l = 0.0_wp
+
 !
 !-- Initialize model variables
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.                                &
          TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
 !
@@ -653,20 +642,20 @@
           IF ( debug_output )  CALL debug_message( 'initializing with INIFOR', 'start' )
 !
-!--       Read initial 1D profiles or 3D data from NetCDF file, depending 
-!--       on the provided level-of-detail. 
-!--       At the moment, only u, v, w, pt and q are provided. 
+!--       Read initial 1D profiles or 3D data from NetCDF file, depending on the provided
+!--       level-of-detail.
+!--       At the moment, only u, v, w, pt and q are provided.
           CALL netcdf_data_input_init_3d
 !
-!--       Please note, Inifor provides data from nzb+1 to nzt. 
-!--       Bottom and top boundary conditions for Inifor profiles are already 
-!--       set (just after reading), so that this is not necessary here.
-!--       Depending on the provided level-of-detail, initial Inifor data is
-!--       either stored on data type (lod=1), or directly on 3D arrays (lod=2). 
-!--       In order to obtain also initial profiles in case of lod=2 (which 
-!--       is required for e.g. damping), average over 3D data.
+!--       Please note, Inifor provides data from nzb+1 to nzt.
+!--       Bottom and top boundary conditions for Inifor profiles are already set (just after
+!--       reading), so that this is not necessary here.
+!--       Depending on the provided level-of-detail, initial Inifor data is either stored on data
+!--       type (lod=1), or directly on 3D arrays (lod=2).
+!--       In order to obtain also initial profiles in case of lod=2 (which is required for e.g.
+!--       damping), average over 3D data.
           IF( init_3d%lod_u == 1 )  THEN
              u_init = init_3d%u_init
-          ELSEIF( init_3d%lod_u == 2 )  THEN 
-             ALLOCATE( init_l(nzb:nzt+1) ) 
+          ELSEIF( init_3d%lod_u == 2 )  THEN
+             ALLOCATE( init_l(nzb:nzt+1) )
              DO  k = nzb, nzt+1
                 init_l(k) = SUM( u(k,nys:nyn,nxl:nxr) )
@@ -675,6 +664,5 @@
 
 #if defined( __parallel )
-             CALL MPI_ALLREDUCE( init_l, u_init, nzt+1-nzb+1,                  &
-                                 MPI_REAL, MPI_SUM, comm2d, ierr )
+             CALL MPI_ALLREDUCE( init_l, u_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
 #else
              u_init = init_l
@@ -683,9 +671,9 @@
 
           ENDIF
-           
-          IF( init_3d%lod_v == 1 )  THEN  
+
+          IF( init_3d%lod_v == 1 )  THEN
              v_init = init_3d%v_init
-          ELSEIF( init_3d%lod_v == 2 )  THEN 
-             ALLOCATE( init_l(nzb:nzt+1) ) 
+          ELSEIF( init_3d%lod_v == 2 )  THEN
+             ALLOCATE( init_l(nzb:nzt+1) )
              DO  k = nzb, nzt+1
                 init_l(k) = SUM( v(k,nys:nyn,nxl:nxr) )
@@ -694,6 +682,5 @@
 
 #if defined( __parallel )
-             CALL MPI_ALLREDUCE( init_l, v_init, nzt+1-nzb+1,                  &
-                                 MPI_REAL, MPI_SUM, comm2d, ierr )
+             CALL MPI_ALLREDUCE( init_l, v_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
 #else
              v_init = init_l
@@ -704,6 +691,6 @@
              IF( init_3d%lod_pt == 1 )  THEN
                 pt_init = init_3d%pt_init
-             ELSEIF( init_3d%lod_pt == 2 )  THEN 
-                ALLOCATE( init_l(nzb:nzt+1) ) 
+             ELSEIF( init_3d%lod_pt == 2 )  THEN
+                ALLOCATE( init_l(nzb:nzt+1) )
                 DO  k = nzb, nzt+1
                    init_l(k) = SUM( pt(k,nys:nyn,nxl:nxr) )
@@ -712,6 +699,5 @@
 
 #if defined( __parallel )
-                CALL MPI_ALLREDUCE( init_l, pt_init, nzt+1-nzb+1,               &
-                                    MPI_REAL, MPI_SUM, comm2d, ierr )
+                CALL MPI_ALLREDUCE( init_l, pt_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
 #else
                 pt_init = init_l
@@ -725,6 +711,6 @@
              IF( init_3d%lod_q == 1 )  THEN
                 q_init = init_3d%q_init
-             ELSEIF( init_3d%lod_q == 2 )  THEN 
-                ALLOCATE( init_l(nzb:nzt+1) ) 
+             ELSEIF( init_3d%lod_q == 2 )  THEN
+                ALLOCATE( init_l(nzb:nzt+1) )
                 DO  k = nzb, nzt+1
                    init_l(k) = SUM( q(k,nys:nyn,nxl:nxr) )
@@ -733,6 +719,5 @@
 
 #if defined( __parallel )
-                CALL MPI_ALLREDUCE( init_l, q_init, nzt+1-nzb+1,               &
-                                    MPI_REAL, MPI_SUM, comm2d, ierr )
+                CALL MPI_ALLREDUCE( init_l, q_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
 #else
                 q_init = init_l
@@ -743,26 +728,21 @@
 
 !
-!--       Write initial profiles onto 3D arrays. 
-!--       Work-around, 3D initialization of u,v,w creates artificial 
-!--       structures wich correlate with the processor grid. The reason
-!--       for this is still unknown. To work-around this, 3D initialization
-!--       will be effectively reduce to a 1D initialization where no such
-!--       artificial structures appear.
+!--       Write initial profiles onto 3D arrays.
+!--       Work-around, 3D initialization of u,v,w creates artificial structures which correlate with
+!--       the processor grid. The reason for this is still unknown. To work-around this, 3D
+!--       initialization will be effectively reduce to a 1D initialization where no such artificial
+!--       structures appear.
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                IF( init_3d%lod_u == 1  .OR.  init_3d%lod_u == 2 )             &
-                   u(:,j,i) = u_init(:)
-                IF( init_3d%lod_v == 1  .OR.  init_3d%lod_u == 2 )             &
-                   v(:,j,i) = v_init(:)
-                IF( .NOT. neutral  .AND.                                       &
-                    ( init_3d%lod_pt == 1  .OR.  init_3d%lod_pt == 2 ) )       &
+                IF( init_3d%lod_u == 1  .OR.  init_3d%lod_u == 2 )  u(:,j,i) = u_init(:)
+                IF( init_3d%lod_v == 1  .OR.  init_3d%lod_u == 2 )  v(:,j,i) = v_init(:)
+                IF( .NOT. neutral  .AND.  ( init_3d%lod_pt == 1  .OR.  init_3d%lod_pt == 2 ) )     &
                    pt(:,j,i) = pt_init(:)
-                IF( humidity  .AND.                                            &
-                    ( init_3d%lod_q == 1  .OR.  init_3d%lod_q == 2 ) )         &
+                IF( humidity  .AND.  ( init_3d%lod_q == 1  .OR.  init_3d%lod_q == 2 ) )            &
                    q(:,j,i) = q_init(:)
              ENDDO
           ENDDO
 !
-!--       Set geostrophic wind components.  
+!--       Set geostrophic wind components.
           IF ( init_3d%from_file_ug )  THEN
              ug(:) = init_3d%ug_init(:)
@@ -790,20 +770,18 @@
 
 !
-!--       Set velocity components at non-atmospheric / oceanic grid points to 
-!--       zero. 
+!--       Set velocity components at non-atmospheric / oceanic grid points to zero.
           u = MERGE( u, 0.0_wp, BTEST( wall_flags_total_0, 1 ) )
           v = MERGE( v, 0.0_wp, BTEST( wall_flags_total_0, 2 ) )
           w = MERGE( w, 0.0_wp, BTEST( wall_flags_total_0, 3 ) )
 !
-!--       Initialize surface variables, e.g. friction velocity, momentum 
-!--       fluxes, etc. 
-          CALL init_surfaces
-
-          IF ( debug_output )  CALL debug_message( 'initializing with INIFOR', 'end' )
+!--       Initialize surface variables, e.g. friction velocity, momentum fluxes, etc.
+          CALL  init_surfaces
+
+          IF ( debug_output )  CALL  debug_message( 'initializing with INIFOR', 'end' )
 !
 !--    Initialization via computed 1D-model profiles
        ELSEIF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
 
-          IF ( debug_output )  CALL debug_message( 'initializing with 1D model profiles', 'start' )
+          IF ( debug_output )  CALL  debug_message( 'initializing with 1D model profiles', 'start' )
 !
 !--       Use solutions of the 1D model as initial profiles,
@@ -833,5 +811,5 @@
                    s(:,j,i) = s_init
                 ENDDO
-             ENDDO   
+             ENDDO
           ENDIF
 !
@@ -843,12 +821,10 @@
 !--       Set velocities back to zero
           u = MERGE( u, 0.0_wp, BTEST( wall_flags_total_0, 1 ) )
-          v = MERGE( v, 0.0_wp, BTEST( wall_flags_total_0, 2 ) )         
-!
-!--       WARNING: The extra boundary conditions set after running the
-!--       -------  1D model impose an error on the divergence one layer
-!--                below the topography; need to correct later 
-!--       ATTENTION: Provisional correction for Piacsek & Williams
-!--       ---------  advection scheme: keep u and v zero one layer below
-!--                  the topography.
+          v = MERGE( v, 0.0_wp, BTEST( wall_flags_total_0, 2 ) )
+!
+!--       WARNING: The extra boundary conditions set after running the 1D model impose an error on
+!--       -------- the divergence one layer below the topography; need to correct later
+!--       ATTENTION: Provisional correction for Piacsek & Williams advection scheme: keep u and v
+!--       ---------- zero one layer below the topography.
           IF ( ibc_uv_b == 1 )  THEN
 !
@@ -863,18 +839,16 @@
           ENDIF
 !
-!--       Initialize surface variables, e.g. friction velocity, momentum 
-!--       fluxes, etc. 
+!--       Initialize surface variables, e.g. friction velocity, momentum fluxes, etc.
           CALL init_surfaces
 
-          IF ( debug_output )  CALL debug_message( 'initializing with 1D model profiles', 'end' )
-
-       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )    &
-       THEN
-
-          IF ( debug_output )  CALL debug_message( 'initializing with constant profiles', 'start' )
-
-!
-!--       Use constructed initial profiles (velocity constant with height,
-!--       temperature profile with constant gradient)
+          IF ( debug_output )  CALL  debug_message( 'initializing with 1D model profiles', 'end' )
+
+       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )  THEN
+
+          IF ( debug_output )  CALL  debug_message( 'initializing with constant profiles', 'start' )
+
+!
+!--       Use constructed initial profiles (velocity constant with height, temperature profile with
+!--       constant gradient)
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -889,20 +863,16 @@
           v = MERGE( v, 0.0_wp, BTEST( wall_flags_total_0, 2 ) )
 !
-!--       Set initial horizontal velocities at the lowest computational grid 
-!--       levels to zero in order to avoid too small time steps caused by the 
-!--       diffusion limit in the initial phase of a run (at k=1, dz/2 occurs
-!--       in the limiting formula!). 
-!--       Please note, in case land- or urban-surface model is used and a 
-!--       spinup is applied, masking the lowest computational level is not 
-!--       possible as MOST as well as energy-balance parametrizations will not 
-!--       work with zero wind velocity. 
-          IF ( ibc_uv_b /= 1  .AND.  .NOT.  spinup )  THEN
+!--       Set initial horizontal velocities at the lowest computational grid levels to zero in order
+!--       to avoid too small time steps caused by the diffusion limit in the initial phase of a run
+!--       (at k=1, dz/2 occurs in the limiting formula!).
+!--       Please note, in case land- or urban-surface model is used and a spinup is applied, masking
+!--       the lowest computational level is not possible as MOST as well as energy-balance
+!--       parametrizations will not work with zero wind velocity.
+          IF ( ibc_uv_b /= 1  .AND.  .NOT. spinup )  THEN
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt
-                      u(k,j,i) = MERGE( u(k,j,i), 0.0_wp,                      &
-                                     BTEST( wall_flags_total_0(k,j,i), 20 ) )
-                      v(k,j,i) = MERGE( v(k,j,i), 0.0_wp,                      &
-                                     BTEST( wall_flags_total_0(k,j,i), 21 ) )
+                      u(k,j,i) = MERGE( u(k,j,i), 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 20 ) )
+                      v(k,j,i) = MERGE( v(k,j,i), 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 21 ) )
                    ENDDO
                 ENDDO
@@ -917,5 +887,5 @@
              ENDDO
           ENDIF
-          
+
           IF ( passive_scalar )  THEN
              DO  i = nxlg, nxrg
@@ -927,22 +897,19 @@
 
 !
-!--       Compute initial temperature field and other constants used in case
-!--       of a sloping surface
+!--       Compute initial temperature field and other constants used in case of a sloping surface.
           IF ( sloping_surface )  CALL init_slope
 !
-!--       Initialize surface variables, e.g. friction velocity, momentum 
-!--       fluxes, etc. 
+!--       Initialize surface variables, e.g. friction velocity, momentum fluxes, etc.
           CALL init_surfaces
-          
+
           IF ( debug_output )  CALL debug_message( 'initializing with constant profiles', 'end' )
 
-       ELSEIF ( INDEX(initializing_actions, 'by_user') /= 0 )                  &
-       THEN
+       ELSEIF ( INDEX(initializing_actions, 'by_user') /= 0 )  THEN
 
           IF ( debug_output )  CALL debug_message( 'initializing by user', 'start' )
 !
-!--       Pre-initialize surface variables, i.e. setting start- and end-indices
-!--       at each (j,i)-location. Please note, this does not supersede 
-!--       user-defined initialization of surface quantities. 
+!--       Pre-initialize surface variables, i.e. setting start- and end-indices at each
+!--       (j,i)-location. Please note, this does not supersede user-defined initialization of
+!--       surface quantities.
           CALL init_surfaces
 !
@@ -954,9 +921,11 @@
        ENDIF
 
-       IF ( debug_output )  CALL debug_message( 'initializing statistics, boundary conditions, etc.', 'start' )
+       IF ( debug_output )  THEN
+          CALL debug_message( 'initializing statistics, boundary conditions, etc.', 'start' )
+       ENDIF
 
 !
 !--    Bottom boundary
-       IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2  )  THEN
+       IF ( ibc_uv_b == 0  .OR.  ibc_uv_b == 2  )  THEN
           u(nzb,:,:) = 0.0_wp
           v(nzb,:,:) = 0.0_wp
@@ -975,8 +944,7 @@
 
 !
-!--    Store initial profiles for output purposes etc.. Please note, in case of 
-!--    initialization of u, v, w, pt, and q via output data derived from larger 
-!--    scale models, data will not be horizontally homogeneous. Actually, a mean 
-!--    profile should be calculated before.   
+!--    Store initial profiles for output purposes etc.. Please note, in case of initialization of u,
+!--    v, w, pt, and q via output data derived from larger scale models, data will not be
+!--    horizontally homogeneous. Actually, a mean profile should be calculated before.
        hom(:,1,5,:) = SPREAD( u(:,nys,nxl), 2, statistic_regions+1 )
        hom(:,1,6,:) = SPREAD( v(:,nys,nxl), 2, statistic_regions+1 )
@@ -989,11 +957,9 @@
        IF ( humidity )  THEN
 !
-!--       Store initial profile of total water content, virtual potential
-!--       temperature 
+!--       Store initial profile of total water content, virtual potential temperature
           hom(:,1,26,:) = SPREAD(   q(:,nys,nxl), 2, statistic_regions+1 )
           hom(:,1,29,:) = SPREAD( vpt(:,nys,nxl), 2, statistic_regions+1 )
 !
-!--       Store initial profile of mixing ratio and potential
-!--       temperature
+!--       Store initial profile of mixing ratio and potential temperature
           IF ( bulk_cloud_model  .OR.  cloud_droplets ) THEN
              hom(:,1,27,:) = SPREAD(  q(:,nys,nxl), 2, statistic_regions+1 )
@@ -1011,13 +977,13 @@
 !--    Initialize the random number generators (from numerical recipes)
        CALL random_function_ini
-       
+
        IF ( random_generator == 'random-parallel' )  THEN
           CALL init_parallel_random_generator( nx, nys, nyn, nxl, nxr )
        ENDIF
 !
-!--    Set the reference state to be used in the buoyancy terms (for ocean runs
-!--    the reference state will be set (overwritten) in init_ocean)
+!--    Set the reference state to be used in the buoyancy terms (for ocean runs the reference state
+!--    will be set (overwritten) in init_ocean).
        IF ( use_single_reference_value )  THEN
-          IF (  .NOT.  humidity )  THEN
+          IF ( .NOT. humidity )  THEN
              ref_state(:) = pt_reference
           ELSE
@@ -1025,5 +991,5 @@
           ENDIF
        ELSE
-          IF (  .NOT.  humidity )  THEN
+          IF ( .NOT. humidity )  THEN
              ref_state(:) = pt_init(:)
           ELSE
@@ -1050,11 +1016,10 @@
 
 !
-!--    Impose temperature anomaly (advection test only) or warm air bubble 
-!--    close to surface
-       IF ( INDEX( initializing_actions, 'initialize_ptanom' ) /= 0  .OR.  &
+!--    Impose temperature anomaly (advection test only) or warm air bubble close to surface.
+       IF ( INDEX( initializing_actions, 'initialize_ptanom' ) /= 0  .OR.                          &
             INDEX( initializing_actions, 'initialize_bubble' ) /= 0  )  THEN
           CALL init_pt_anomaly
        ENDIF
-       
+
 !
 !--    If required, change the surface temperature at the start of the 3D run
@@ -1066,10 +1031,10 @@
 !--    If required, change the surface humidity/scalar at the start of the 3D
 !--    run
-       IF ( humidity  .AND.  q_surface_initial_change /= 0.0_wp )              &
+       IF ( humidity  .AND.  q_surface_initial_change /= 0.0_wp )                                  &
           q(nzb,:,:) = q(nzb,:,:) + q_surface_initial_change
-          
-       IF ( passive_scalar .AND.  s_surface_initial_change /= 0.0_wp )         &
+
+       IF ( passive_scalar  .AND.  s_surface_initial_change /= 0.0_wp )                            &
           s(nzb,:,:) = s(nzb,:,:) + s_surface_initial_change
-        
+
 
 !
@@ -1082,11 +1047,13 @@
           q_p = q
        ENDIF
-       
+
        IF ( passive_scalar )  THEN
           ts_m = 0.0_wp
           s_p  = s
-       ENDIF       
-
-       IF ( debug_output )  CALL debug_message( 'initializing statistics, boundary conditions, etc.', 'end' )
+       ENDIF
+
+       IF ( debug_output )  THEN
+          CALL debug_message( 'initializing statistics, boundary conditions, etc.', 'end' )
+       ENDIF
 
     ELSEIF ( TRIM( initializing_actions ) == 'read_restart_data'  .OR.         &
@@ -1094,20 +1061,19 @@
     THEN
 
-       IF ( debug_output )  CALL debug_message( 'initializing in case of restart / cyclic_fill', 'start' )
-!
-!--    Initialize surface elements and its attributes, e.g. heat- and 
-!--    momentumfluxes, roughness, scaling parameters. As number of surface 
-!--    elements might be different between runs, e.g. in case of cyclic fill, 
-!--    and not all surface elements are read, surface elements need to be 
-!--    initialized before. 
-!--    Please note, in case of cyclic fill, surfaces should be initialized 
-!--    after restart data is read, else, individual settings of surface 
-!--    parameters will be overwritten from data of precursor run, hence, 
-!--    init_surfaces is called a second time after reading the restart data. 
-       CALL init_surfaces                        
-!
-!--    When reading data for cyclic fill of 3D prerun data files, read
-!--    some of the global variables from the restart file which are required
-!--    for initializing the inflow
+       IF ( debug_output )  THEN
+          CALL debug_message( 'initializing in case of restart / cyclic_fill', 'start' )
+       ENDIF
+!
+!--    Initialize surface elements and its attributes, e.g. heat- and momentumfluxes, roughness,
+!--    scaling parameters. As number of surface elements might be different between runs, e.g. in
+!--    case of cyclic fill, and not all surface elements are read, surface elements need to be
+!--    initialized before.
+!--    Please note, in case of cyclic fill, surfaces should be initialized after restart data is
+!--    read, else, individual settings of surface parameters will be overwritten from data of
+!--    precursor run, hence, init_surfaces is called a second time after reading the restart data.
+       CALL init_surfaces
+!
+!--    When reading data for cyclic fill of 3D prerun data files, read some of the global variables
+!--    from the restart file which are required for initializing the inflow
        IF ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
 
